from bs4 import BeautifulSoup
from data import Thread, Post
import urllib2
import re

ONLINE = True
URL = 'http://4-ch.net/code'
OFFLINE_BOARD = "board.htm"
OFFLINE_THREAD = "thread.htm"

def get_threadlist():
    if ONLINE:
      print "Loading board: %s" % URL
      soup = BeautifulSoup(_get_url(URL), "html.parser")
    else:
      print "Loading offline board: %s" % OFFLINE_BOARD
      soup = BeautifulSoup(open(OFFLINE_BOARD), "html.parser")

    threadlist = []
    threads = soup.find_all("span", class_="threadlink")
    __re_title = re.compile(r"(\d+): (.*) \((\d+)\)")
    __re_link = re.compile(r"kareha.pl/(\d+)(/l50)?")
    
    for thread in threads:
        links = thread.find_all('a')
        title = unicode(links[0].string)
        
        try:
            #title += links[1]['href']
            title += unicode(links[1].string)
        except IndexError:
            pass
        
        title = title.replace('\n', ' ')
        title_matches = __re_title.match(title)
        link_matches = __re_link.search(links[0]['href'])
        
        t_num = int(title_matches.group(1))
        t_title = title_matches.group(2).strip()
        t_replies = int(title_matches.group(3))
        t_id = int(link_matches.group(1))
        
        t = Thread(t_id, t_num, t_title, t_replies)
        threadlist.append(t)
    
    fullthreads = soup.find_all("div", class_="thread")
    
    i = 0
    for fullthread in fullthreads:
        threadlist[i].posts = _parse_thread(fullthread)
        
        i += 1
    
    return threadlist

def get_thread(threadid):
    if ONLINE:
      soup = BeautifulSoup(_get_url('%s/kareha.pl/%d/l50' % (URL, threadid)), "html.parser")
    else:
      soup = BeautifulSoup(open(OFFLINE_THREAD), "html.parser")
    
    t_thread = soup.find("div", class_="thread")
    
    header = list(t_thread.find("h2").stripped_strings)
    title = unicode(header[0])
    replies = int(header[1][1:-1])
    
    return Thread(0, 0, title, replies, _parse_thread(t_thread))

def _parse_thread(fullthread):
    replies = fullthread.find_all("div", class_="reply")
    replylist = []
    
    for reply in replies:
        r_num = int(reply.find("span", class_="replynum").string)
        r_name = unicode(reply.find("span", class_="postername").string)
        r_text = "\n\n".join(reply.find("div", class_="replytext").strings)
        r_stamp = reply.find("h3").contents[5].strip()[2:]
        
        r = Post(r_num, r_name, '', r_stamp, r_text)
        replylist.append(r)
    
    return replylist

def _get_url(url):
    response = urllib2.urlopen(url)
    return response.read()

#get_thread(0)
